/*
 * TimeTrigger.java
 *
 * Created on 23 de febrero de 2004, 19:01
 */

package org.jtgl.gaming;

/**
 * Provides a thread-less time trigger suitable for animations, etc..
 * @author  Manuel Polo (manuel_polo at yahoo dot es)
 */
public class TimeTrigger {
    private Triggerable client;
    private long prevTime;
    private long prevDelay;
    private long delay;
    private boolean enabled;
    public boolean isTime;    
    
    /** Creates a new instance of TimeTrigger */
    public TimeTrigger() {
        this(100);
    }
    /** Creates a new instance of TimeTrigger */
    public TimeTrigger(long delay) {
        setDelay(delay);
        setEnabled(true);
    }
    
    public void setDelay(long delay){
        this.delay = delay;
    }
    
    public long getDelay(){
        return delay;
    }
    
    public void setEnabled(boolean enabled){
        this.enabled = enabled;
    }
    
    public boolean isEnabled(){
        return enabled;
    }
    
    public void setTriggerable(Triggerable client){
        this.client = client;
    }

    public Triggerable getTriggerable(){
        return client;
    }
    
    public boolean checkTime(){
        return checkTime(System.currentTimeMillis());
    }
    
    public void reset(){
        prevTime = System.currentTimeMillis();
    }
    
    public boolean checkTime(long currentTime){                
        isTime = false;
        if(prevTime == 0)
            prevTime = currentTime;
        prevDelay += currentTime - prevTime;
        if(prevDelay >= delay){
            if(enabled && client != null)
                client.triggerAction();
            isTime = true;
            prevDelay = prevDelay - delay; //adjust timming differences
        }        
        prevTime = currentTime;
        return isTime && enabled;
    }
    
}
